# 1.1 【环境】快速安装 Python 解释器

Python 是一门解释性脚本语言，因此要想让你编写的代码得以运行，需要先安装 CPython 解释器。

根据你电脑的系统以及位数不同，安装步骤也有所差异。

- Windows 系统：系统无自带 Python 解释器，需要自行安装
- Mac 系统：系统自带 Python 2.7，需要自行安装 Python 3

由于 Python 2.x 已经不再维护了，因此本文会带大家安装CPython 最新版本： Python 3.9 （截止撰稿时最新：2020/12/16）。

同时本系列教程都将以 Python 3.9 版本进行讲解，不负责任的讲，可能是全网最新的 零基础系列教程。

## 1. 下载解释器

进入 [Python 官网](https://www.python.org/downloads/windows/)，目前 Python 最新 Python 稳定版为 3.9，点击如下链接 

![](http://image.iswbm.com/image-20201129172024424.png)

直接跳到最后，根据你电脑系统以及的位数

- Win 32 位：选择 [Windows x86 executable installer](https://www.python.org/ftp/python/3.9.0/python-3.9.0.exe)
- Win 64 位：选择 [Windows x86-64 executable installer](https://www.python.org/ftp/python/3.9.0/python-3.9.0-amd64.exe)
- Mac ：[Python-3.9.1-macosx10.9.pkg](https://www.python.org/ftp/python/3.9.1/python-3.9.1-macosx10.9.pkg)

![](http://image.iswbm.com/image-20201129172153677.png)

下载下来后，根据你的电脑系统选择后面的内容进行阅读。

## 2. Win 安装

下载到本地后，双击打开开始安装

![](http://image.iswbm.com/20201207164009.png)

记得勾选 `Add Python 3.9 to PATH`，这是把你的 Python 路径加入到系统环境变量中。如果不想自定义选择安装路径，可以直接点击 `Install Now`，如果要选择安装路径，点击下图位置。

![](http://image.iswbm.com/20201207164148.png)

然后全部选上，然后点击  Next 

![](http://image.iswbm.com/20201207164207.png)

这里根据需要进行打勾，一般默认就行，然后点击 `Browse` ，选择你想要把 Python 安装到的哪那个目录里。

然后再直接点击  Install 开始安装。

![](http://image.iswbm.com/20201207164309.png)

安装过程只要几分钟就行

![](http://image.iswbm.com/20201207164451.png)

出现如下界面，说明安装过程已经结束。

![](http://image.iswbm.com/20201207164957.png)

安装是安装上了，那么如何验证呢？

使用 windows 搜索 cmd，选择 `命令提示符` （我们把这个称之为你的终端）

![](http://image.iswbm.com/20201207165111.png)

然后敲入 python ，若出现如下界面，则说明 Python 已经成功安装到你的机器上。

![](http://image.iswbm.com/20201218200632.png)

## 3. Mac 安装

下载到本地后，双击打开开始安装

![](http://image.iswbm.com/image-20201215124444268.png)

出现如下界面，一直点继续

![](http://image.iswbm.com/image-20201215124456818.png)

直到出现如下界面，输入密码开始安装

![](http://image.iswbm.com/image-20201215124710859.png)

安装的速度非常地快，大概在一分钟左右

![](http://image.iswbm.com/image-20201215124720398.png)

![](http://image.iswbm.com/image-20201215124935041.png)

打开Terminal 或者 iTerm（同样我们把这个称之为你的终端），输入 Python 3 ，如果进入如下界面，说明 Python3 已经安装完成。

![](http://image.iswbm.com/image-20201215125120591.png)
