# 2.2 【基础】字符串类型

## 1. 如何定义字符串？

字符串是Python中最常用的数据类型之一。

使用单引号或双引号来创建字符串，使用三引号创建多行字符串。字符串要么使用两个单引号，要么两个双引号，不能一单一双！Python不支持单字符类型，单字符在Python中也是作为一个字符串使用。

以下四种写法是等价的

```python
>>> name_1 = 'Jack'  # 单引号
>>> name_2 = "Jack"  # 双引号
>>> name_3 =  '''Jack''' # 三个单引号
>>> name_4 = """Jack"""  # 三个双引号
>>> name_1 == name_2 == name_3 == name_4
True
```

如果一个字符串里，要有引号，那么最好和外部包裹的引号类型不同，比如

- 外层使用单引号，那么里层使用双引号

```python
>>> msg = "my name is 'Jack'"
>>> msg
"my name is 'Jack'"
```

- 外层使用双引号，那么里层使用单引号

```python
>>> msg = 'my name is "Jack"'
>>> msg
'my name is "Jack"'
```

若想使用一样的符号呢？那字符串里的引号前记得加转义符号：`\`

```python
>>> msg = 'what\'s you name?'
>>> msg
"what's you name?"
```

## 2. 常用的方法

字符串对象本身自带了许多非常实用的方法，考虑到新手的接受程序，在这里也没必要一一给你介绍。

本篇文章只会为你介绍最常用的那些方法，而剩下的你只要在需要的时候去过一下文档就 OK了。

**去除首尾空格**

```python
>>> msg = "    Python编程时光    "
>>>
>>> msg.lstrip()  # 去除左边空格
'Python编程时光    '
>>> msg.rstrip()  # 去除右边空格
'    Python编程时光'
>>>
>>> msg.strip()  # 去除左右两边空格
'Python编程时光'
```

**判断字符串是否以某字符串开头**

```python
>>> msg = "Hello, Python"
>>>
>>> msg.startswith("Hello")
True
>>> msg.startswith("hello")
False
```

**判断字符串是否以某字符串结尾**

```python
>>> msg = "Hello, Python"
>>>
>>> msg.endswith("Python")
True
>>> msg.endswith("python")
False
```

**格式化字符串**：格式化字符串非常重要，在后面的章节中我有非常详细的讲解，这里你简单了解即可

```python
>>> name = "王炳明"
>>> msg = f"你好，我是{name}"
>>> msg
'你好，我是王炳明'
```

**分割字符串**：以逗号为分割符分割字符串

```python
>>> languages = "Python,Java,Golang"
>>> languages.split(",")
['Python', 'Java', 'Golang']
```